﻿Public Class Form1

    ' Redraw on resize.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.ResizeRedraw = True
    End Sub

    ' Draw some smiley faces.
    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Me.Paint
        e.Graphics.SmoothingMode = _
            System.Drawing.Drawing2D.SmoothingMode.AntiAlias

        Dim smiley_rect As New RectangleF(-1, -1, 2, 2)
        Dim wid As Single = (Me.ClientSize.Width - 1) / 2
        Dim hgt As Single = (Me.ClientSize.Height - 1) / 2

        ' Draw in the upper left quarter.
        MapDrawing(e.Graphics, smiley_rect, New RectangleF(0, 0, wid, hgt), False)
        DrawSmiley(e.Graphics)

        ' Draw in the lower left quarter.
        MapDrawing(e.Graphics, smiley_rect, New RectangleF(0, hgt, wid, hgt), False)
        DrawSmiley(e.Graphics)

        ' Draw in the right side.
        MapDrawing(e.Graphics, smiley_rect, New RectangleF(wid, 0, wid, 2 * hgt), True)
        DrawSmiley(e.Graphics)
    End Sub

    ' Map a drawing coordinate rectangle to a graphics object rectangle.
    Private Sub MapDrawing(ByVal gr As Graphics, ByVal drawing_rect As RectangleF, ByVal target_rect As RectangleF, Optional ByVal stretch As Boolean = False)
        gr.ResetTransform()

        ' Center the drawing area at the origin.
        Dim drawing_cx As Single = (drawing_rect.Left + drawing_rect.Right) / 2
        Dim drawing_cy As Single = (drawing_rect.Top + drawing_rect.Bottom) / 2
        gr.TranslateTransform(-drawing_cx, -drawing_cy)

        ' Scale.
        ' Get scale factors for both directions.
        Dim scale_x As Single = target_rect.Width / drawing_rect.Width
        Dim scale_y As Single = target_rect.Height / drawing_rect.Height
        If (Not stretch) Then
            ' To preserve the aspect ratio, use the smaller scale factor.
            scale_x = Math.Min(scale_x, scale_y)
            scale_y = scale_x
        End If
        gr.ScaleTransform(scale_x, scale_y, _
            System.Drawing.Drawing2D.MatrixOrder.Append)

        ' Translate to center over the drawing area.
        Dim graphics_cx As Single = (target_rect.Left + target_rect.Right) / 2
        Dim graphics_cy As Single = (target_rect.Top + target_rect.Bottom) / 2
        gr.TranslateTransform(graphics_cx, graphics_cy, _
            System.Drawing.Drawing2D.MatrixOrder.Append)
    End Sub

    ' Draw a smiley face in the area (-1, -1)-(1, 1).
    Private Sub DrawSmiley(ByVal gr As Graphics)
        Using thin_pen As New Pen(Color.Black, 0)
            gr.FillEllipse(Brushes.Yellow, -1, -1, 2, 2)
            gr.DrawEllipse(thin_pen, -1, -1, 2, 2)

            gr.FillEllipse(Brushes.LightGreen, -0.5F, -0.5F, 0.3F, 0.5F)
            gr.DrawEllipse(thin_pen, -0.5F, -0.5F, 0.3F, 0.5F)
            gr.FillEllipse(Brushes.Black, -0.4F, -0.4F, 0.2F, 0.3F)

            gr.FillEllipse(Brushes.LightGreen, 0.2F, -0.5F, 0.3F, 0.5F)
            gr.DrawEllipse(thin_pen, 0.2F, -0.5F, 0.3F, 0.5F)
            gr.FillEllipse(Brushes.Black, 0.3F, -0.4F, 0.2F, 0.3F)

            gr.FillEllipse(Brushes.LightBlue, -0.2F, -0.1F, 0.4F, 0.6F)
            gr.DrawEllipse(thin_pen, -0.2F, -0.1F, 0.4F, 0.6F)

            gr.DrawArc(thin_pen, -0.75F, -0.75F, 1.5F, 1.5F, 20, 120)
        End Using
    End Sub
End Class
